/***************************************************************************
 * Artekit_DS1340.h
 * Copyright (C) 2014 Artekit Italy
 * http://www.artekit.eu
 *
 * This class provides support for the AK-DS1340 RTC with Trickle Charger,
 * to be used with Arduino.
 * This class depends on the Wire.h library, that must be included in
 * the main sketch.
 *
 * Product page:
 * http://www.artekit.eu/products/breakout-boards/ak-ds1340/
 *
***************************************************************************/

#ifndef __ARTEKIT_DS1340_H__
#define __ARTEKIT_DS1340_H__

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

typedef struct _DATETIME
{
    uint8_t second;
    uint8_t minute;
    uint8_t hour;
    uint8_t day;
    uint8_t month;
    uint16_t year;
    uint8_t day_of_week;
} DATETIME;

class Artekit_DS1340
{
public:

    Artekit_DS1340();
    ~Artekit_DS1340();
    
    void GetTime(DATETIME* dt);
    void SetTime(DATETIME* dt);
    const char* GetDayOfWeek(uint8_t day_of_week);
    void EnableTrickleCharger();
    void DisableTrickleCharger();
    void EnableFTOUT();
    void DisableFTOUT();
    uint8_t ReadControlReg();
    void WriteControlReg(uint8_t value);
};

#endif /* __ARTEKIT_DS1340_H__ */
